/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModelProperty;
import org.threeten.bp.LocalDate;

import java.util.Objects;

/**
 * PrescriptionResponse
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class PrescriptionResponse {
  @SerializedName("medical_consultation_id")
  private String medicalConsultationId = null;

  @SerializedName("prescription_id")
  private String prescriptionId = null;

  @SerializedName("status")
  private String status = null;

  @SerializedName("valid_until")
  private LocalDate validUntil = null;

  @SerializedName("recipient_type")
  private String recipientType = null;

  @SerializedName("selected_recipient")
  private SelectedRecipient selectedRecipient = null;

  @SerializedName("attachment")
  private Model43 attachment = null;

  public PrescriptionResponse medicalConsultationId(String medicalConsultationId) {
    this.medicalConsultationId = medicalConsultationId;
    return this;
  }

   /**
   * Medical consultation identifier
   * @return medicalConsultationId
  **/
  @ApiModelProperty(example = "2", required = true, value = "Medical consultation identifier")
  public String getMedicalConsultationId() {
    return medicalConsultationId;
  }

  public void setMedicalConsultationId(String medicalConsultationId) {
    this.medicalConsultationId = medicalConsultationId;
  }

  public PrescriptionResponse prescriptionId(String prescriptionId) {
    this.prescriptionId = prescriptionId;
    return this;
  }

   /**
   * Prescription identifier
   * @return prescriptionId
  **/
  @ApiModelProperty(example = "1", required = true, value = "Prescription identifier")
  public String getPrescriptionId() {
    return prescriptionId;
  }

  public void setPrescriptionId(String prescriptionId) {
    this.prescriptionId = prescriptionId;
  }

  public PrescriptionResponse status(String status) {
    this.status = status;
    return this;
  }

   /**
   * Prescription status - Expected value (IDENTIFIED, WRITTEN, SENT)
   * @return status
  **/
  @ApiModelProperty(example = "WRITTEN", value = "Prescription status - Expected value (IDENTIFIED, WRITTEN, SENT)")
  public String getStatus() {
    return status;
  }

  public void setStatus(String status) {
    this.status = status;
  }

  public PrescriptionResponse validUntil(LocalDate validUntil) {
    this.validUntil = validUntil;
    return this;
  }

   /**
   * Date of end of validity of the prescription - ISO 8601 format (YYYY-MM-DD)
   * @return validUntil
  **/
  @ApiModelProperty(required = true, value = "Date of end of validity of the prescription - ISO 8601 format (YYYY-MM-DD)")
  public LocalDate getValidUntil() {
    return validUntil;
  }

  public void setValidUntil(LocalDate validUntil) {
    this.validUntil = validUntil;
  }

  public PrescriptionResponse recipientType(String recipientType) {
    this.recipientType = recipientType;
    return this;
  }

   /**
   * Type of recipient for the prescription : Pharmacy, Medical Laboratory, Radiologist, ...
   * @return recipientType
  **/
  @ApiModelProperty(example = "Pharmacy", value = "Type of recipient for the prescription : Pharmacy, Medical Laboratory, Radiologist, ...")
  public String getRecipientType() {
    return recipientType;
  }

  public void setRecipientType(String recipientType) {
    this.recipientType = recipientType;
  }

  public PrescriptionResponse selectedRecipient(SelectedRecipient selectedRecipient) {
    this.selectedRecipient = selectedRecipient;
    return this;
  }

   /**
   * Get selectedRecipient
   * @return selectedRecipient
  **/
  @ApiModelProperty(value = "")
  public SelectedRecipient getSelectedRecipient() {
    return selectedRecipient;
  }

  public void setSelectedRecipient(SelectedRecipient selectedRecipient) {
    this.selectedRecipient = selectedRecipient;
  }

  public PrescriptionResponse attachment(Model43 attachment) {
    this.attachment = attachment;
    return this;
  }

   /**
   * Get attachment
   * @return attachment
  **/
  @ApiModelProperty(value = "")
  public Model43 getAttachment() {
    return attachment;
  }

  public void setAttachment(Model43 attachment) {
    this.attachment = attachment;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PrescriptionResponse prescriptionResponse = (PrescriptionResponse) o;
    return Objects.equals(this.medicalConsultationId, prescriptionResponse.medicalConsultationId) &&
        Objects.equals(this.prescriptionId, prescriptionResponse.prescriptionId) &&
        Objects.equals(this.status, prescriptionResponse.status) &&
        Objects.equals(this.validUntil, prescriptionResponse.validUntil) &&
        Objects.equals(this.recipientType, prescriptionResponse.recipientType) &&
        Objects.equals(this.selectedRecipient, prescriptionResponse.selectedRecipient) &&
        Objects.equals(this.attachment, prescriptionResponse.attachment);
  }

  @Override
  public int hashCode() {
    return Objects.hash(medicalConsultationId, prescriptionId, status, validUntil, recipientType, selectedRecipient, attachment);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PrescriptionResponse {\n");
    
    sb.append("    medicalConsultationId: ").append(toIndentedString(medicalConsultationId)).append("\n");
    sb.append("    prescriptionId: ").append(toIndentedString(prescriptionId)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    validUntil: ").append(toIndentedString(validUntil)).append("\n");
    sb.append("    recipientType: ").append(toIndentedString(recipientType)).append("\n");
    sb.append("    selectedRecipient: ").append(toIndentedString(selectedRecipient)).append("\n");
    sb.append("    attachment: ").append(toIndentedString(attachment)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

